package dev.shadowsoffire.apotheosis.ench.api;

import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.core.particles.ParticleOptions;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry;
import net.minecraft.core.Vec3i;
import net.minecraft.util.RandomSource;
import net.minecraft.world.level.Level;
import java.util.Collections;
import net.minecraft.world.item.enchantment.Enchantment;
import java.util.Set;
import org.jetbrains.annotations.ApiStatus;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraftforge.common.extensions.IForgeBlock;

public interface IEnchantingBlock extends IForgeBlock
{
    @ApiStatus.OverrideOnly
    default float getMaxEnchantingPower(final BlockState state, final LevelReader world, final BlockPos pos) {
        return 15.0f;
    }
    
    @ApiStatus.OverrideOnly
    default float getQuantaBonus(final BlockState state, final LevelReader world, final BlockPos pos) {
        return 0.0f;
    }
    
    @ApiStatus.OverrideOnly
    default float getArcanaBonus(final BlockState state, final LevelReader world, final BlockPos pos) {
        return 0.0f;
    }
    
    @ApiStatus.OverrideOnly
    default float getQuantaRectification(final BlockState state, final LevelReader world, final BlockPos pos) {
        return 0.0f;
    }
    
    @ApiStatus.OverrideOnly
    default int getBonusClues(final BlockState state, final LevelReader world, final BlockPos pos) {
        return 0;
    }
    
    default Set<Enchantment> getBlacklistedEnchantments(final BlockState state, final LevelReader world, final BlockPos pos) {
        return Collections.emptySet();
    }
    
    default void spawnTableParticle(final BlockState state, final Level level, final RandomSource rand, final BlockPos pos, final BlockPos offset) {
        if (rand.m_188503_(16) == 0 && EnchantingStatRegistry.getEterna(level.m_8055_(pos.m_121955_((Vec3i)offset)), level, pos.m_121955_((Vec3i)offset)) > 0.0f && level.m_46859_(pos.m_7918_(offset.m_123341_() / 2, 0, offset.m_123343_() / 2))) {
            level.m_7106_(this.getTableParticle(state), pos.m_123341_() + 0.5, pos.m_123342_() + 2.0, pos.m_123343_() + 0.5, offset.m_123341_() + rand.m_188501_() - 0.5, (double)(offset.m_123342_() - rand.m_188501_() - 1.0f), offset.m_123343_() + rand.m_188501_() - 0.5);
        }
    }
    
    default ParticleOptions getTableParticle(final BlockState state) {
        return (ParticleOptions)ParticleTypes.f_123809_;
    }
    
    default boolean allowsTreasure(final BlockState state, final LevelReader world, final BlockPos pos) {
        return false;
    }
}
